package config;

#	This file is part of SurrealServices.
#
#	SurrealServices is free software; you can redistribute it and/or modify
#	it under the terms of the GNU General Public License as published by
#	the Free Software Foundation; either version 2 of the License, or
#	(at your option) any later version.
#
#	SurrealServices is distributed in the hope that it will be useful,
#	but WITHOUT ANY WARRANTY; without even the implied warranty of
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#	GNU General Public License for more details.
#
#	You should have received a copy of the GNU General Public License
#	along with SurrealServices; if not, write to the Free Software
#	Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use FreezeThaw;

our %conf;

sub loadconfig {
	%conf = readHash("$main::prefix/config/main.conf");
}

sub writeArray {
        my $array = $_[0];
        my $file = $_[1];

        open ARRAY, ">$file";

        foreach my $x (@$array) {
                print ARRAY $x . "\n";
        }

        close ARRAY;
}

sub readArray {
        my $file = $_[0];
        my @array;

        open ARRAY, $file;

        while(my $x = <ARRAY>) {
                chomp $x;
                push @array, $x;
        }

        close ARRAY;

        return (@array);
}

sub writeHash {
        my $hash = $_[0];
        my $file = $_[1];

        open HASH, ">$file";

        my @keys = keys(%$hash); my @values = values(%$hash);

        for(my $i=0; $i<@keys; $i++) {
                if($values[$i][0]) {
                        chomp $keys[$i];
                        print HASH $keys[$i], " =[ ";
                        foreach my $atom (@{$values[$i]}) {
                                print HASH $atom, ", ";
                        }
                        print HASH "\n";
                } else {
                        chomp $keys[$i]; chomp $values[$i];
                        print HASH $keys[$i], " = ", $values[$i], "\n";
                }
        }

        close HASH;
}

sub readHash {
        my $file = $_[0];
        my %hash;

        open HASH, $file;
        while(my $line = <HASH>) {
                if($line =~ / =\[ /) {
                        my ($key, $value) = split(/ =\[ /, $line);
                        chomp $key; chomp $value;
                        $hash{$key} = [ split(/, /, $value) ];
                } else {
                        my ($key, $value) = split(/ = /, $line);
                        chomp $key; chomp $value;
                        $hash{$key} = $value;
                }
        }
        close HASH;

        return (%hash);
}

sub dsave {
	my ($data, $file) = @_;

	my $x = FreezeThaw::freeze($data);
	open FILE, ">$file";
	print FILE $x;
	close FILE;
}

sub dload {
	my ($file) = @_;

	open FILE, $file;
	my $in = <FILE>;
	my ($x) = FreezeThaw::thaw($in) if $in;
	close FILE;

	return $x;
}

1;
